﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class SharkAlarm : Mod
{
    public static SharkAlarm instance;

    Gradient colorG = new Gradient();

    GradientColorKey white = new GradientColorKey(Color.white, 0);
    GradientColorKey red = new GradientColorKey(Color.red, 1);

    AssetBundle bundle;
    GameObject canvasPrefab;
    GameObject canvas;

    AI_NetworkBehavior_Shark bruce;

    float distanceMulti = 30f;

    Image[] imagess;

    Network_Player player;

    void ChangeDistMulti(string[] args)
    {
        if (args.Length != 1)
        {
            Debug.Log("wrong argument");
        }


        float multi;
        float.TryParse(args[0], out multi);
        PlayerPrefs.SetFloat("TR.SHARKFINDER.DISTMULTI", multi);
        distanceMulti = multi;
    }

    private IEnumerator Start()
    {
        instance = this;

        if (!PlayerPrefs.HasKey("TR.SHARKFINDER.DISTMULTI"))
        {
            PlayerPrefs.SetFloat("TR.SHARKFINDER.DISTMULTI", 30.0f);
        }
        else
        {
            distanceMulti = PlayerPrefs.GetFloat("TR.SHARKFINDER.DISTMULTI", 30.0f);
        }

        GradientColorKey[] gradients = new GradientColorKey[2];
        gradients[0] = white;
        gradients[1] = red;
        colorG.colorKeys = gradients;

        

        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("sharkfinder.assets"));
        yield return request;
        bundle = request.assetBundle;

        canvasPrefab = bundle.LoadAsset<GameObject>("SharkFinderCanvas");

        Debug.Log("SharkAlarm loaded!");
    }

    public void Update()
    {

        if (player == null)
        {
            player = RAPI.GetLocalPlayer();
            return;
        }

        if (SceneManager.GetActiveScene().name == Raft_Network.GameSceneName)
        {
            if (canvas != null)
            {
                Destroy(canvas);
            }
            return;
        }
        else
        {
            if (canvas != null)
            {
                canvas.SetActive(true);
            }
        }

        if (canvas == null)
        {
            canvas = Instantiate(canvasPrefab);
            imagess = canvas.GetComponentsInChildren<Image>();
            return;
        }

        if (bruce == null)
        {
            bruce = GameObject.FindObjectOfType<AI_NetworkBehavior_Shark>();
            return;
        }

        if (bruce.IsKilled)
        {
            return;
        }
        float distance = Vector3.Distance(bruce.transform.position, player.transform.position) / distanceMulti;

        for (int i = 0; i < imagess.Length; i++)
        {
            if (imagess[i].name != "Image")
            {
                if (distance > 1)
                {
                    imagess[i].color = colorG.Evaluate(0);
                }
                else
                {
                    imagess[i].color = colorG.Evaluate(1 - distance);
                }
            }
        }

    }

    public void OnModUnload()
    {
        bundle.Unload(true);
        Debug.Log("SharkAlarm has been unloaded!");
    }

    [ConsoleCommand(name: "distMulti", docs: "Sets the Distance multiplier for the sharkometer")]
    public static void distMultiCommand(string[] args)
    {
        instance.ChangeDistMulti(args);
    }
}